package plaver.qrcode_new;

public class BitToString {

    private char[] alphaNumeric;
    
    private String results = "";
    private int BOUNDUPPER = 5;
    private int BOUNDLOW = 0;
    private boolean v[] = new boolean[5];
    private int count = 0;

    public BitToString(){
        this.fillAlphaNumeric();
    }
    
    private void fillAlphaNumeric() {
        this.alphaNumeric = new char[32];
        
        char numeric = 0x0030;
        for(int i=0; i < 10; ++i){
            this.alphaNumeric[i] = numeric;
            //System.out.println("Char: " + numeric);
            ++numeric;
        }
        
        char alpha = 0x0041;
        for(int i=10; i < 32; ++i){
            this.alphaNumeric[i] = alpha;
            //System.out.println("Char: " + alpha);
            ++alpha;
        }
    }
    
    public void addBits(boolean v[]){
        for(int i=0; i<v.length; ++i)
            this.addBit(v[i]);
    }
    
    public void addBit(boolean checker) {

        //System.out.println("METODO INVOCADO");
        v[count++] = checker;

        if (count == this.BOUNDUPPER) {
            this.putUnicodeResult();
        }
    }

    private void putUnicodeResult() {
        int c = (int) 0x00;
        for (int i = 0; i < count; ++i) {
            c = ((int) c << 1);
            if (v[i] == true) {
                c = (int) c | 0x00000001;
            }
            //System.out.println(String.valueOf("Bin: " + Integer.toBinaryString(c)));
        }
        this.results += this.alphaNumeric[c];
        //System.out.println("C: " + c);
        count = 0;
    }

    private void completingConversion() {

        for (int i = count; i < BOUNDUPPER; ++i) {
            v[count++] = false;
        }

        this.putUnicodeResult();
    }

    public String getString() {

        if (this.count != this.BOUNDLOW) {
            this.completingConversion();

        }
        return this.results;
    }
}
