/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package plaver.dtvtest;

import com.sun.dtv.lwuit.Form;


/**
 * @author GILBERTO FARIAS
 * @author Bruno Pessoa
 */
public interface DTVTest {	

	int AUTO 		 = 1;
	int INTERACTIVE  = 2;
    
    /**
     * Adiciona o <code>form</code> principal da aplicao.
     *
     * O <code>form</code> deve ser usado apenas em aplicaes que requerem a exibio de componentes grficos
     * na tela.
     * 
     * @param form objeto compartilhado entre todas as aplicaes de teste
     */
    public void setForm(Form form);
    

    /**
     * @param log objeto responsvel pela sinalizao do resultado do teste
     */
	public void setLog(DTVTestLog log);
	
    /**
     * Aloca e reserva os recursos para o teste
     */
    public void init();
    
    /**
     * Mtodo responsvel pela execuo do teste
     */
    public void start();    
    
    /**
     * Pausa a execuo do teste
     */    
    public void pause();
    
    /**
     * Libera listeners e recursos alocados.
     */
    public void destroy();
    
}
